## mia 2.4.4

=== CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2015 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

PROJECT("mia")

# now need OBJECT libraries 
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.8 FATAL_ERROR)

if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
  cmake_policy(SET CMP0012 NEW)
  IF(${CMAKE_VERSION} VERSION_GREATER 3.0.0) 
    cmake_policy(SET CMP0042 NEW)
  ENDIF()
endif(COMMAND cmake_policy)

# This test is added for the Ninja generator, since it 
# has problems with relinking when installing 
# 
STRING(COMPARE EQUAL "${CMAKE_SYSTEM_NAME}" "Linux" SYSTEM_IS_LINUX)
IF(${SYSTEM_IS_LINUX})
  SET(CMAKE_EXECUTABLE_FORMAT "ELF")
ENDIF()

include(FindPkgConfig)
include(CheckCXXSourceCompiles)

# Making releases:
#   MICRO_VERSION += 1;
#   INTERFACE_AGE += 1;
#   BINARY_AGE += 1;
# if any functions have been added, set INTERFACE_AGE to 0.
# if backwards compatibility has been broken,
# set BINARY_AGE and INTERFACE_AGE to 0.


SET(VENDOR "Gert Wollny")
SET(PACKAGE_NAME "mia")
SET(MAJOR_VERSION 2)
SET(MINOR_VERSION 4)
SET(MICRO_VERSION 4)
SET(INTERFACE_AGE 0)
SET(BINARY_AGE    0)

#
#SET(CMAKE_BUILD_WITH_INSTALL_RPATH 1)

SET(PACKAGE_VERSION "${MAJOR_VERSION}.${MINOR_VERSION}.${MICRO_VERSION}")
SET(VERSION "${MAJOR_VERSION}.${MINOR_VERSION}")
SET(MIA_NAME "${PACKAGE_NAME}-${VERSION}")
SET(prefix ${CMAKE_INSTALL_PREFIX})
SET(PLUGIN_OUTPUT "${CMAKE_BINARY_DIR}/plugins")

SET(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

MATH(EXPR MIA_CURRENT "${MICRO_VERSION} - ${BINARY_AGE}")
SET(MIA_REVISION ${INTERFACE_AGE})
MATH(EXPR MIA_AGE "${BINARY_AGE} - ${INTERFACE_AGE}")

SET(LIBRARY_SOVERSION_INFO "${MIA_CURRENT}")
SET(LIBRARY_VERSION_INFO "${MIA_CURRENT}.${MIA_AGE}.${MIA_REVISION}")

OPTION(STRICT_DEPENDECIES "require that all requested optinal dependencies are availabe" FALSE)
OPTION(ALWAYS_CREATE_DOC "Create all documentation during the normal build process (normally you need to run 'make doc')" TRUE)
OPTION(BUILD_EXAMPLES "Build example plug-ins and programs" FALSE)
OPTION(ENABLE_DEBUG_MESSAGES "Enable debug and trace outputs" TRUE)
OPTION(ENABLE_COVERAGE "Enable code coverage tests" FALSE)
OPTION(DISABLE_PROGRAMS "Don't build the programs nor documentation (only for testing purposes)" FALSE)
OPTION(MIA_CREATE_USERDOC "Enable creation of html user documentation" TRUE)




INCLUDE(GNUInstallDirs)

INCLUDE (CheckIncludeFiles)
INCLUDE (TestBigEndian)
INCLUDE (${CMAKE_CURRENT_SOURCE_DIR}/cmake/macros.cmake)
INCLUDE (${CMAKE_CURRENT_SOURCE_DIR}/cmake/pluginmacro.cmake)
INCLUDE (CheckTypeSize)
INCLUDE (CheckIncludeFileCXX)

include(CheckCXXCompilerFlag)


MESSAGE(STATUS "Compiler is ${CMAKE_CXX_COMPILER_ID} version ${CMAKE_CXX_COMPILER_VERSION}")

IF (((${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU") AND
      (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 5.3.0)) OR
    ((${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang") AND
      (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 3.3.0)))
  MESSAGE(STATUS "Compiler  has full c++11 support")

  # g++ >= 6.0 sets std=c++14 by default
  IF ((${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU") AND
      (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 6.0.0))  
    SET(CXX_11_FLAG "-std=c++11")
  ENDIF()
  
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  ${CXX_11_FLAG} -fvisibility=hidden")
ELSE()
  CHECK_CXX_COMPILER_FLAG("-std=c++11" HAS_GNU_CXX11_FLAG)
  IF(HAS_GNU_CXX11_FLAG)
    SET(CXX_11_FLAG "-std=c++11")
  ELSE(HAS_GNU_CXX11_FLAG)
    CHECK_CXX_COMPILER_FLAG("-std=c++0x" HAS_GNU_CXX0X_FLAG)
    IF(HAS_GNU_CXX0X_FLAG)
      SET(CXX_11_FLAG "-std=c++0x")
    ELSE(HAS_GNU_CXX0X_FLAG)
      MESSAGE(WARNING "Don't know how to enable C++11, if you are lucky, they are enabled by default")
    ENDIF(HAS_GNU_CXX0X_FLAG)
  ENDIF(HAS_GNU_CXX11_FLAG)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  ${CXX_11_FLAG} -fvisibility=hidden")
  INCLUDE (${CMAKE_CURRENT_SOURCE_DIR}/cmake/checkCpp0xAuto.cmake)
  INCLUDE (${CMAKE_CURRENT_SOURCE_DIR}/cmake/checkCpp0xLambda.cmake)
  IF(NOT "${CXX_HAS_CXX_0X_AUTO}" OR NOT CXX_HAS_CXX_0X_LAMBDA)
    MESSAGE(FATAL_ERROR 
      "This source code requires the C++0x auto type and lambda features. "
      "If your compiler is supposed to support this feature, "
      "please enable the appropriate flags and delete the CMakeCache.txt file before "
      "re-running cmake.\n"
      "For g++ >= 4.8 this is '-std=c++0x' ")
  ENDIF(NOT "${CXX_HAS_CXX_0X_AUTO}" OR NOT CXX_HAS_CXX_0X_LAMBDA)
ENDIF()

# older versions of g++ libstdc++ don't implement regex sufficiently good
# to be useful
IF ((${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU") AND
    (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 5.3.0))
  SET(MIA_USE_BOOST_REGEX_PRESET FALSE)
ELSE()
  SET(MIA_USE_BOOST_REGEX_PRESET TRUE)
ENDIF()
  
OPTION(MIA_USE_BOOST_REGEX "Use the boost::regex library (instead of c++11 build in) " ${MIA_USE_BOOST_REGEX_PRESET})

IF (ENABLE_COVERAGE)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage -O0 -g -DMIA_COVERAGE")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} --coverage")
  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} --coverage")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} --coverage")
ENDIF()

INCLUDE (${CMAKE_CURRENT_SOURCE_DIR}/cmake/checkSSEAttributeVectorCanUseSubscript.cmake)

INCLUDE (${CMAKE_CURRENT_SOURCE_DIR}/cmake/checkAltivecEnabled.cmake)
INCLUDE (${CMAKE_CURRENT_SOURCE_DIR}/cmake/checkSSEEnabled.cmake)

ASSERT_SIZE(char 1)
ASSERT_SIZE(short 2)
ASSERT_SIZE(int 4)
ASSERT_SIZE(float 4)
ASSERT_SIZE(double 8)

CHECK_TYPE_SIZE(long LONG_TYPE_SIZE)


IF (${LONG_TYPE_SIZE} EQUAL 8)
  SET(LONG_64BIT TRUE)
ELSE(${LONG_TYPE_SIZE} EQUAL 8)
  SET(LONG_64BIT FALSE)
ENDIF(${LONG_TYPE_SIZE} EQUAL 8)

TEST_BIG_ENDIAN(WORDS_BIGENDIAN)
CHECK_INCLUDE_FILES (unistd.h HAVE_UNISTD_H)
CHECK_INCLUDE_FILES (sys/ioctl.h HAVE_SYS_IOCTL_H)
CHECK_INCLUDE_FILES (execinfo.h HAVE_EXEINFO_H)


CHECK_INCLUDE_FILE_CXX (cxxabi.h HAVE_CXXABI_H)


# find additional packages
#
# With MSVC using pre-installed dynamic libraries is usually a pain because of
# the incompatibilities in the compiler flags
#
IF (MSVC)
  SET(SEARCH_LIBS_DEFAULT FALSE)
ELSE(MSVC)
  SET(SEARCH_LIBS_DEFAULT TRUE)
ENDIF (MSVC)




# Taken from ITK:
# On Visual Studio 8 MS deprecated C. This removes all 1.276E1265 security
# warnings
IF(MSVC)
  ADD_DEFINITIONS(
    -D_CRT_FAR_MAPPINGS_NO_DEPRECATE
    -D_CRT_IS_WCTYPE_NO_DEPRECATE
    -D_CRT_MANAGED_FP_NO_DEPRECATE
    -D_CRT_NONSTDC_NO_DEPRECATE
    -D_CRT_SECURE_NO_DEPRECATE
    -D_CRT_SECURE_NO_DEPRECATE_GLOBALS
    -D_CRT_SETERRORMODE_BEEP_SLEEP_NO_DEPRECATE
    -D_CRT_TIME_FUNCTIONS_NO_DEPRECATE
    -D_CRT_VCCLRIT_NO_DEPRECATE
    -D_SCL_SECURE_NO_DEPRECATE
    -D_SECURE_SCL=0
    )
ENDIF(MSVC)

SET(SOURCE_ROOT "${CMAKE_CURRENT_SOURCE_DIR}")
SET(BUILD_ROOT "${CMAKE_CURRENT_BINARY_DIR}")
SET(LIB_ROOT_INSTALL_PATH "${CMAKE_INSTALL_FULL_LIBDIR}/${MIA_NAME}")
SET(CONFIG_INSTALL_PATH "${LIB_ROOT_INSTALL_PATH}/config")
SET(LIB_INCLUDE_INSTALL_PATH "${LIB_ROOT_INSTALL_PATH}/include")
SET(PLUGIN_INSTALL_PATH "${LIB_ROOT_INSTALL_PATH}/plugins")
SET(PLUGIN_SEARCH_PATH "${PLUGIN_INSTALL_PATH}")
SET(DOC_INSTALL_PATH "share/doc/${MIA_NAME}")
SET(FULL_DOC_INSTALL_PATH "${CMAKE_INSTALL_PREFIX}/${DOC_INSTALL_PATH}")
SET(BINARY_INSTALL_PATH "${CMAKE_INSTALL_BINDIR}")
SET(LIBRARY_INSTALL_PATH "${CMAKE_INSTALL_LIBDIR}")
SET(INCLUDE_INSTALL_PATH "${CMAKE_INSTALL_INCLUDEDIR}/${MIA_NAME}")
SET(MIA_DOCTOOLS_INSTALL_ROOT "${CMAKE_INSTALL_PREFIX}/share/mia-doctools")

######################################################################################
#
# Handle BOOST
#
#
MACRO(GET_BOOST_LINKERFLAG VAR LIBNAMES)
  FOREACH(L  ${LIBNAMES})
    STRING(REGEX MATCH "boost_[-_a-z0-9]*" temp ${L})
    STRING(LENGTH "${temp}" TEMP_LENGTH)
    IF(${TEMP_LENGTH})
      SET(flags "${flags} -l${temp}")
    ENDIF(${TEMP_LENGTH})
  ENDFOREACH(L  ${LIBNAMES})
  
  SET(${VAR} "${flags}")
ENDMACRO(GET_BOOST_LINKERFLAG)

SET(BOOST_COMPONENTS filesystem  unit_test_framework serialization system)

IF (MIA_USE_BOOST_REGEX)
  SET(BOOST_COMPONENTS  ${BOOST_COMPONENTS} regex)
ENDIF()

IF (WIN32)
  SET(BOOST_COMPONENTS  ${BOOST_COMPONENTS} date_time)
ENDIF(WIN32)

FIND_PACKAGE( Boost 1.50.0 COMPONENTS
  ${BOOST_COMPONENTS}
  REQUIRED)

INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIR})
LINK_DIRECTORIES(${Boost_LIBRARY_DIRS})

ADD_DEFINITIONS(-DBOOST_ALL_DYN_LINK)
ADD_DEFINITIONS(-DBOOST_FILESYSTEM_VERSION=3)

IF (MIA_USE_BOOST_REGEX)
  SET(BOOST_DEPS ${Boost_REGEX_LIBRARY}  ${Boost_FILESYSTEM_LIBRARY} ${Boost_SYSTEM_LIBRARY})
ELSE()
  SET(BOOST_DEPS ${Boost_FILESYSTEM_LIBRARY} ${Boost_SYSTEM_LIBRARY})
ENDIF()

SET(BOOST_UNITTEST  ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY})

IF (WIN32 AND NOT UNIX)
   FOREACH(l 
       ${Boost_REGEX_LIBRARIES}
       ${Boost_FILESYSTEM_LIBRARY}
       ${Boost_SYSTEM}
       ${Boost_DATE_TIME}
       )
      STRING(REGEX MATCH "lib$" head ${l})
      STRING(COMPARE EQUAL "xlib" "x${head}" islib)
      IF (${islib})
	  STRING(REGEX REPLACE "lib$" "dll" lDLL ${l})
	  INSTALL(FILES ${lDLL} DESTINATION "bin")
      ENDIF(${islib})
   ENDFOREACH(l)
ENDIF (WIN32 AND NOT UNIX)

IF (MSYS OR MINGW)
  SET(BASELIBS ${BOOST_DEPS})
ENDIF (MSYS OR MINGW)

#
# end BOOST 
#
################################################################################

################################################################################
#
# Intel Threading Building Blocks 
#
OPTION(WITH_TBB "Use intel threading building blocks for threading, otherwise use c++11 threads" OFF)

IF(WITH_TBB) 
  FIND_PACKAGE(TBB REQUIRED)
  IF(TBB_FOUND) 
    include_directories(${TBB_INCLUDE_DIRS})
    link_directories(${TBB_LIBRARY_DIRS})
    SET(HAVE_TBB 1)
  ELSE(TBB_FOUND) 
    MESSAGE(FATAL " TBB not found")
  ENDIF(TBB_FOUND)
ENDIF()
#
# End Intel Threading Building Blocks 
#
################################################################################

################################################################################
#
# Intel Threading Building Blocks 
# why is this here? 

SET(CMAKE_THREAD_PREFER_PTHREAD ON) 
FIND_PACKAGE(Threads)

IF(CMAKE_USE_PTHREADS_INIT)
  set(PTHREADLIB -lpthread)
ENDIF(CMAKE_USE_PTHREADS_INIT)

################################################################################
# 
# Handle the GNU Scientific Library, this might be a showstopper 
# on MS windows when using Visual C++ 
#
PKG_CHECK_MODULES(GSL REQUIRED gsl)
INCLUDE_DIRECTORIES(${GSL_INCLUDE_DIRS})
LINK_DIRECTORIES(${GSL_LIBRARY_DIRS})


PKG_CHECK_MODULES(EIGEN3 REQUIRED eigen3)
INCLUDE_DIRECTORIES(${EIGEN3_INCLUDE_DIRS})
LINK_DIRECTORIES(${EIGEN3_LIBRARY_DIRS})


IF(UNIX)
  GET_BOOST_LINKERFLAG(BOOST_LIBFLAG "${BOOST_DEPS}")
  SET(MIA_DEPEND_LIBRARIES "${BOOST_LIBFLAG} ${TBB_LIBRARIES} ${PTHREADLIB} -ldl")
ENDIF(UNIX)

##################################################################################
#
# Find gzip for man page compression 
#
find_program(GZIP gzip)
IF(NOT GZIP) 
  MESSAGE(gzip not found, man pages will not be compressed)
ENDIF(NOT GZIP) 

##################################################################################
#
# take care of modules loading infrastructure
#
IF(NOT WIN32)

  FIND_LIBRARY(DL dl
    PATH
    /lib
    /usr/lib
    /opt/local/lib
    /sw/lib
  )
  IF(DL_NOTFOUND)
    MESSAGE(FATAL_ERROR "non-windows systems without libdl.so are not yet supported")
  ENDIF(DL_NOTFOUND)

=== mia/2d/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2015 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

SET(MIA2D_SRC_BASE
  angle.cc
  boundingbox.cc
  correlation_weight.cc 
  cost.cc
  creator.cc
  cstkernel.cc 
  datafield.cc
  distance.cc
  filter.cc
  image.cc
  imageio.cc
  interpolator.cc 
  fftkernel.cc
  fuzzyseg.cc
  fuzzyclustersolver_sor.cc
  fuzzyclustersolver_cg.cc
  fullcost.cc
  maskedcost.cc 
  model.cc
  morphshape.cc
  multicost.cc
  nfg.cc
  nonrigidregister.cc 
  polygon.cc
  ppmatrix.cc
  rgbimageio.cc
  rigidregister.cc
  shape.cc
  similarity_profile.cc
  sparse_image_solver.cc
  splinetransformpenalty.cc
  timestep.cc
  trackpoint.cc
  transform.cc
  transformio.cc
  transformfactory.cc
  vectorfield.cc
  vfio.cc
  vfregularizer.cc
  vfregularizerkernel.cc
  )


SET(SEG_SRC 
  segframe.cc 
  segpoint.cc 
  segsection.cc 
  segset.cc
  segsetwithimages.cc
  segstar.cc 
  )
SET(SEG_HEADER 
  segpoint.hh
  segstar.hh
  segsection.hh
  segframe.hh
  segset.hh
  segsetwithimages.hh
  )

SET(MIA2D_SRC ${MIA2D_SRC_BASE} ${MIA2D_FFTW_CODE})

SET(MIA2D_HEADERS_BASE
  angle.hh
  boundingbox.hh
  cost.hh
  correlation_weight.hh 
  creator.hh
  cstkernel.hh 
  datafield.hh datafield.cxx
  defines2d.hh
  deformer.hh
  distance.hh
  fftkernel.hh
  filter.hh
  fullcost.hh
  fuzzyseg.hh
  fuzzyclustersolver_sor.hh
  fuzzyclustersolver_cg.hh
  ground_truth_evaluator.hh
  groundtruthproblem.hh
  image.hh
  imageio.hh
  imageiotest.hh
  interpolator.hh interpolator.cxx
  iterator.hh
  iterator.cxx
  matrix.hh
  maskedcost.hh 
  model.hh
  morphshape.hh
  multicost.hh
  nonrigidregister.hh
  nfg.hh
  perfusion.hh
  polygon.hh
  ppmatrix.hh
  rgbimageio.hh
  rigidregister.hh
  shape.hh
  similarity_profile.hh
  sparse_image_solver.hh
  splinetransformpenalty.hh
  timestep.hh
  trait.hh
  trackpoint.hh
  transform.hh
  transformmock.hh
  transformio.hh
  transformfactory.hh
  vector.hh
  vectorfield.hh
  vfio.hh
  vfregularizer.hh
  vfregularizerkernel.hh
  )

SET(MIA2D_HEADERS ${MIA2D_HEADERS_BASE} ${SEG_HEADER} ${ITPP_HEADER})

#
# the main 2D library
# 
MIA_ADD_LIBRARY(mia2d "${MIA2D_SRC}" miacore)

#
# What we need to link from here on 
#
SET(MIA2DLIBS mia2d  ${LIBS})


#
# The test library: On MS windows it needs to be static, 
# because it doesen't resolve all
# symbols, and in Windows, this is not supported# 
SET(mia2dtestsrc 
  imageiotest.cc 
  vfiotest.cc 
  imagetest.cc
  transformmock.cc
  )
SET(mia2dlibdeps mia2d ${BOOST_UNITTEST})

MIA_ADD_LIBRARY(mia2dtest "${mia2dtestsrc}" "${mia2dlibdeps}")
SET_TARGET_PROPERTIES(mia2dtest PROPERTIES COMPILE_FLAGS -DBOOST_TEST_DYN_LINK)


IF(APPLE)
   SET_TARGET_PROPERTIES(mia2dtest PROPERTIES LINK_FLAGS "-single_module -Wl,-flat_namespace -Wl,-undefined -Wl,suppress")
ENDIF(APPLE)

MACRO(TEST_2DMIA file libs)
  ADD_EXECUTABLE(test-2d-${file} test_${file}.cc)
  TARGET_LINK_LIBRARIES(test-2d-${file} ${libs} ${BOOST_UNITTEST} )
  ADD_TEST(2d-${file} test-2d-${file})
ENDMACRO(TEST_2DMIA file)

TEST_2DMIA(angle mia2d)
TEST_2DMIA(datafield mia2dtest)
TEST_2DMIA(image mia2dtest)
TEST_2DMIA(filter mia2dtest)
TEST_2DMIA(param mia2dtest)
TEST_2DMIA(vector mia2dtest)
TEST_2DMIA(boundingbox mia2dtest)
TEST_2DMIA(distance mia2dtest)
TEST_2DMIA(fullcost mia2dtest)
TEST_2DMIA(interpol mia2dtest)
TEST_2DMIA(matrix mia2dtest)
TEST_2DMIA(nfg mia2dtest)
TEST_2DMIA(cost mia2dtest)
TEST_2DMIA(iterator mia2dtest)
TEST_2DMIA(nonrigidregister mia2dtest)
TEST_2DMIA(oldnewintegrate mia2dtest)
TEST_2DMIA(combiner mia2dtest)
TEST_2DMIA(polygon mia2dtest)
TEST_2DMIA(ppmatrix mia2dtest)
TEST_2DMIA(rigidregister mia2dtest)
TEST_2DMIA(transformfactory mia2dtest)
TEST_2DMIA(vectorfield mia2dtest)
TEST_2DMIA(similarity_profile mia2dtest)
TEST_2DMIA(transio mia2d)
TEST_2DMIA(transform mia2dtest)
TEST_2DMIA(shape mia2dtest)
TEST_2DMIA(morphshape mia2dtest)
TEST_2DMIA(imageio mia2dtest)
TEST_2DMIA(sparse_image_solver mia2dtest)
TEST_2DMIA(filter_cast mia2d)
TEST_2DMIA(splinetransformpenalty mia2d)
TEST_2DMIA(trackpoint mia2dtest)

IF(CMAKE_BUILD_TYPE)
  SET(CONFIG ${CMAKE_BUILD_TYPE})
ELSE(CMAKE_BUILD_TYPE)
  SET(CONFIG "NOCONFIG")
ENDIF(CMAKE_BUILD_TYPE)

#
# installation 
#
INSTALL_WITH_EXPORT(mia2d)
INSTALL_WITH_EXPORT(mia2dtest)

INSTALL(FILES ${MIA2D_HEADERS} DESTINATION ${INCLUDE_INSTALL_PATH}/mia/2d)



SET(MIA2D_MYOCARDPERF_SRC 
  ${SEG_SRC}
  ground_truth_evaluator.cc
  groundtruthproblem.cc
  ica.cc 
  perfusion.cc
  )  

SET(MIA2D_MYOCARDPERF_HEADER 
  ${SEG_HEADER}
  ground_truth_evaluator.hh
  groundtruthproblem.hh
  ica.hh
  perfusion.hh
  )  

MIA_ADD_LIBRARY(mia2dmyocardperf "${MIA2D_MYOCARDPERF_SRC}" mia2d)

INSTALL_WITH_EXPORT(mia2dmyocardperf)
INSTALL(FILES ${MIA2D_MYOCARDPERF_HEADER} DESTINATION ${INCLUDE_INSTALL_PATH}/mia/2d)

IF(ITPP_FOUND)
  TEST_2DMIA(ica mia2dmyocardperf)
  TEST_2DMIA(perfusion mia2dmyocardperf)
ENDIF(ITPP_FOUND)

set(testperflibs mia2dmyocardperf mia2dtest)

TEST_2DMIA(groundtruthproblem mia2dmyocardperf)
TEST_2DMIA(correlation_weight mia2dmyocardperf)
TEST_2DMIA(segmentation mia2dmyocardperf)
TEST_2DMIA(segframe "${testperflibs}")
TEST_2DMIA(segpoint mia2dmyocardperf)


#
# The plugin directories 
#
ADD_SUBDIRECTORY(cost      )
ADD_SUBDIRECTORY(combiner  )
ADD_SUBDIRECTORY(creator   )
ADD_SUBDIRECTORY(io        )
ADD_SUBDIRECTORY(filter    )
ADD_SUBDIRECTORY(fft       )
ADD_SUBDIRECTORY(fullcost  )
ADD_SUBDIRECTORY(kernel    )
ADD_SUBDIRECTORY(model     )
ADD_SUBDIRECTORY(maskedcost)
ADD_SUBDIRECTORY(rgbio     )
ADD_SUBDIRECTORY(shapes    )
#ADD_SUBDIRECTORY(sparseimgsolver )
ADD_SUBDIRECTORY(timestep  )
ADD_SUBDIRECTORY(transform )
ADD_SUBDIRECTORY(transio )
ADD_SUBDIRECTORY(splinepenalty )
ADD_SUBDIRECTORY(vfregularizer )
ADD_SUBDIRECTORY(vfregularizerkernel )

=== mia/3d/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2016 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

SET(MIA3D_SRC 
  affine_matrix.cc
  camera.cc
  cost.cc
  creator.cc
  critical_point.cc
  2dimagefifofilter.cc
  datafield.cc
  distance.cc
  filter.cc
  fullcost.cc
  fuzzyseg.cc
  fuzzyclustersolver_cg.cc
  ica.cc 
  image.cc
  imagedraw.cc
  imageio.cc
  imagecollect.cc
  interpolator.cc
  landmark.cc
  landmarklist.cc
  landmarklistio.cc
  maskedcost.cc
  matrix.cc 
  model.cc
  multicost.cc
  nfg.cc 
  nonrigidregister.cc
  orientation.cc
  ppmatrix.cc 
  quaternion.cc
  register.cc
  rigidregister.cc
  rot.cc
  shape.cc
  similarity_profile.cc
  splinetransformpenalty.cc
  stackdisttrans.cc
  timestep.cc
  trackpoint.cc
  transform.cc
  transformfactory.cc
  transformio.cc
  vectorfield.cc
  vfregularizer.cc
  vfregularizerkernel.cc
  vfio.cc
  )

SET(MIA3D_HEADERS
  affine_matrix.hh
  2dimagefifofilter.hh
  datafield.hh datafield.cxx
  image.hh
  filter.hh
  ica.hh
  imagedraw.cc
  imageio.hh
  imagetest.hh
  imageiotest.hh
  camera.hh
  cost.hh
  creator.hh
  critical_point.hh
  defines3d.hh
  deformer.hh
  distance.hh
  fifotestfixture.hh
  fullcost.hh
  fuzzyseg.hh
  fuzzyclustersolver_cg.hh
  interpolator.hh interpolator.cxx
  iterator.hh iterator.cxx
  ica.hh
  imagecollect.hh
  landmark.hh
  landmarklist.hh
  landmarklistio.hh
  maskedcost.hh
  matrix.hh
  model.hh
  multicost.hh
  multireg.hh
  nfg.hh
  nonrigidregister.hh
  orientation.hh
  ppmatrix.hh
  quaternion.hh
  register.hh
  rigidregister.hh
  rot.hh
  shape.hh
  similarity_profile.hh
  stackdisttrans.hh
  splinetransformpenalty.hh
  timestep.hh
  trackpoint.hh
  trait.hh
  transform.hh
  transformfactory.hh
  transformio.hh
  transformmock.hh
  valueattributetranslator.hh
  vector.hh
  vectorfield.hh
  vfregularizer.hh
  vfregularizerkernel.hh
  vfio.hh
  vfiotest.hh
  )

SET(MIA3DTEST_SRC
  test_3d.cc
  test_datafield.cc
  test_image.cc
  test_vector.cc
  test_interpol.cc
  )



#
# The main 3D library
#
MIA_ADD_LIBRARY(mia3d "${MIA3D_SRC}" mia2d)

MACRO(TEST_3D name)
  ADD_EXECUTABLE(test-3d-${name} test_${name}.cc)  
  TARGET_LINK_LIBRARIES(test-3d-${name} mia3dtest ${BOOST_UNITTEST})
  ADD_TEST(3d-${name} test-3d-${name})
  IF(WIN32)
    SET_TARGET_PROPERTIES(test-3d-${name} PROPERTIES LINKER_FLAGS "/NODEFAULTLIB:MSVCRT")
  ENDIF(WIN32)
ENDMACRO(TEST_3D name)


SET(MIA3DLIBS mia3d  ${LIBS})
#
# io test library 
#

SET(mia3dtestsrc 
  imageiotest.cc 
  imagetest.cc 
  vfiotest.cc 
  fifotestfixture.cc
  transformmock.cc
  )
SET(mia3dtestdeps ${MIA3DLIBS} mia2dtest ${BOOST_UNITTEST})

MIA_ADD_LIBRARY(mia3dtest "${mia3dtestsrc}" "${mia3dtestdeps}")
SET_TARGET_PROPERTIES(mia3dtest PROPERTIES COMPILE_FLAGS -DBOOST_TEST_DYN_LINK)

IF(APPLE)
  SET_TARGET_PROPERTIES(mia3dtest PROPERTIES LINK_FLAGS "-single_module -Wl,-flat_namespace -Wl,-undefined -Wl,suppress")
ENDIF(APPLE)

#
# Testing 
#
ADD_EXECUTABLE(test-3d ${MIA3DTEST_SRC})
SET_TARGET_PROPERTIES(test-3d PROPERTIES COMPILE_FLAGS -DBOOST_TEST_DYN_LINK)
TARGET_LINK_LIBRARIES(test-3d mia3dtest ${MIA3DLIBS} ${BOOST_UNITTEST})

SET(TEST_3D test-3d)

IF (WIN32)
  ADD_TEST(3d "${CMAKE_CURRENT_SOURCE_DIR}/test-3d.bat")
ELSE (WIN32)
  ADD_TEST(3d test-3d)
ENDIF(WIN32)

TEST_3D(affine_matrix affine_matrix)
TEST_3D(critical_points)
TEST_3D(2dimagefifofilter imagefifofilter)
TEST_3D(nfg nfg)
TEST_3D(vectorfield vectorfield)
TEST_3D(orientation orientation)
TEST_3D(deform deform)
TEST_3D(ica ica)
TEST_3D(transformfactory transformfactory)
TEST_3D(rigidregister rigidregister)
TEST_3D(nonrigidregister nonrigidregister)
TEST_3D(transform transform)
TEST_3D(transio transio)
TEST_3D(landmark landmark)
TEST_3D(landmarklistio landmarklistio)
TEST_3D(quaternion quaternion)
TEST_3D(ppmatrix ppmatrix)
TEST_3D(matrix matrix)
TEST_3D(fullcost fullcost)
TEST_3D(iterator iterator)
TEST_3D(stackdisttrans stackdisttrans)
TEST_3D(similarity_profile similarity_profile)
TEST_3D(trackpoint similarity_profile)
TEST_3D(distance distance)
TEST_3D(imagecollect imagecollect)
TEST_3D(imagedraw imagedraw)
TEST_3D(rot rot)
TEST_3D(splinetransformpenalty splinetransformpenalty)

TEST_3D(imageio imageio)
#
# installation 
#
SET(INSTALL_TARGETS mia3d mia3dtest)	
INSTALL_WITH_EXPORT("${INSTALL_TARGETS}")
INSTALL(FILES ${MIA3D_HEADERS} DESTINATION ${INCLUDE_INSTALL_PATH}/mia/3d)

#
# sub directories (plugins) 
#
ADD_SUBDIRECTORY(cost     )
ADD_SUBDIRECTORY(combiner )
ADD_SUBDIRECTORY(creator  )
ADD_SUBDIRECTORY(filter   )
ADD_SUBDIRECTORY(fifof    )
ADD_SUBDIRECTORY(fullcost )
ADD_SUBDIRECTORY(io       )
ADD_SUBDIRECTORY(lmio)
ADD_SUBDIRECTORY(maskedcost )
ADD_SUBDIRECTORY(reg3d    )
ADD_SUBDIRECTORY(shapes   )
ADD_SUBDIRECTORY(splinepenalty  )
ADD_SUBDIRECTORY(transform)
ADD_SUBDIRECTORY(transio)
ADD_SUBDIRECTORY(vfregularizerkernel)
ADD_SUBDIRECTORY(vfregularizer)

=== mia/core/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2015 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

SET(GSLPP_SOURCE 
  gsl_matrix.cc
  gsl_matrix_vector_ops.cc
  gsl_multimin.cc
  gsl_pca.cc 
  gsl_vector.cc
  gsl_wavelet.cc
  )

SET(GSLPP_HEADERS 
  gsl_matrix.hh
  gsl_matrix_vector_ops.hh
  gsl_multimin.hh
  gsl_pca.hh
  gsl_vector.hh
  gsl_wavelet.hh
  gsl_defines.hh
  )

SET(MIACORE_SRC_BASE
  ${GSLPP_SOURCE} 
  attributes.cc 
  attribute_names.cc 
  boundary_conditions.cc
  callback.cc 
  cost.cc 
  combiner.cc
  convergence_measure.cc
  cmdlineparser.cc
  cmdoption.cc
  cmdstringoption.cc
  cmdbooloption.cc
  cmeans.cc
  creator.cc
  datapool.cc
  distance.cc
  dlloader.cc
  dummyhandler.cc
  errormacro.cc
  fastica_nonlinearity.cc
  file.cc 
  filetools.cc 
  filter.cc
  fixedwidthoutput.cc
  fft1d_r2c.cc 
  fftslopeclassifier.cc
  flagstring.cc
  fullstats.cc
  handlerbase.cc
  history.cc
  ica.cc
  index.cc
  info.cc
  interpolator1d.cc
  iodata.cc
  ioplugin.cc
  kmeans.cc
  labelmap.cc
  mitestimages.cc
  module.cc
  msgstream.cc 
  minimizer.cc
  nccsum.cc 
  noisegen.cc 
  optionparser.cc 
  optparam.cc
  paramoption.cc  
  parameter.cc  
  paramtranslator.cc  
  pixeltype.cc 
  plugin_base.cc  
  product_base.cc
  productcache.cc
  property_flags.cc
  probmap.cc
  regmodel.cc
  revision.cc 
  scaler1d.cc
  searchpath.cc
  seriesstats.cc 
  selftestcmdoption.cc
  shape.cc 
  slopestatistics.cc
  slopeclassifier.cc
  spacial_kernel.cc
  sparse_histogram.cc
  splinekernel.cc
  splineparzenmi.cc
  sqmin.cc
  streamredir.cc
  testplugin.cc 
  threadedmsg.cc
  typedescr.cc
  utils.cc 
  watch.cc 
  waveletslopeclassifier.cc
  xmlinterface.cc
  )

SET(MIACORE_HEADER_BASE
  ${GSLPP_HEADERS}
  attributes.hh
  attribute_names.hh 
  attributetype.hh
  boundary_conditions.hh
  callback.hh
  cmdbooloption.hh
  cmdlineparser.hh
  cmdoption.hh
  cmdparamoption.hh
  cmdoptionflags.hh
  cmdstringoption.hh
  cmeans.hh
  combiner.hh
  convergence_measure.hh
  cost.hh
  cost.cxx
  combiner.hh
  creator.hh
  cstplan.hh
  datapool.hh
  defines.hh
  delayedparameter.hh
  dictmap.hh
  distance.hh
  dlloader.hh
  dummyhandler.hh
  errormacro.hh
  export_handler.hh
  factory.hh
  factory_trait.hh
  fastica_nonlinearity.hh
  fft1d_r2c.hh
  fftslopeclassifier.hh
  fifofilter.hh
  file.hh
  filetools.hh
  filter.hh
  fixedwidthoutput.hh
  flags.hh
  flagstring.hh
  fullstats.hh
  handlerbase.hh
  handler.cxx handler.hh
  history.hh
  histogram.hh
  ica.hh
  ica_template.hh
  ica_template.cxx
  index.hh
  import_handler.hh
  iodata.hh
  iohandler.cxx iohandler.hh
  ioplugin.cxx ioplugin.hh
  kmeans.hh
  labelmap.hh
  meanvar.hh
  mitestimages.hh
  module.hh
  msgstream.hh
  minimizer.hh
  noisegen.hh
  nccsum.hh
  optionparser.hh
  optparam.hh
  parallel.hh
  parallelcxx11.hh
  parameter.cxx parameter.hh
  paramoption.hh
  paramtranslator.hh
  pixeltype.hh
  plugin_base.cxx plugin_base.hh
  probmap.hh
  property_flags.hh
  product_base.hh
  productcache.hh
  refholder.hh
  regmodel.hh
  scaler1d.hh
  shape.hh shape.cxx
  searchpath.hh
  seriesstats.hh
  selftestcmdoption.hh
  singular_refobj.hh
  slopestatistics.hh
  slopeclassifier.hh
  slopevector.hh
  splinekernel.hh
  splineparzenmi.hh
  spacial_kernel.hh
  sparse_histogram.hh
  sparse_solver.hh
  sqmin.hh
  statistics.hh
  streamredir.hh
  svector.hh
  testplugin.hh
  threadedmsg.hh
  tools.hh
  traits.hh
  transformation.hh
  typedescr.hh
  type_traits.hh
  utils.hh
  vector.hh
  watch.hh
  waveletslopeclassifier.hh
  xmlinterface.hh
  )

SET(MIACORETEST_SRC 
  test_core_combined.cc
)

IF(NOT TBB_FOUND)
  SET(MIACORE_SRC_PARALLELCXX11 
    parallelcxx11.cc
    )
  NEW_TEST(parallelcxx11 miacore)
ENDIF(NOT TBB_FOUND)
  
IF(PWPDF_FOUND) 
  SET(PWPDF_SRC 
    pwh.cc
    )
  SET(PWPDF_HEADER 
    pwh.hh
    )
ENDIF(PWPDF_FOUND) 

MACRO(CORE_TEST name)
  ADD_EXECUTABLE(test-${name} test_${name}.cc)  
  TARGET_LINK_LIBRARIES(test-${name} ${MIACORE} ${BOOST_UNITTEST})
  ADD_TEST(core-${name} test-${name})
  IF(WIN32)
    SET_TARGET_PROPERTIES(test-${name} PROPERTIES LINKER_FLAGS "/NODEFAULTLIB:MSVCRT")
  ENDIF(WIN32)
ENDMACRO(CORE_TEST name)

#
# create the revision retrival code
#
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/revision.hh.cmake ${CMAKE_CURRENT_BINARY_DIR}/revision.hh)


#
# the library target 
#
SET(MIACORE_SRC ${MIACORE_SRC_BASE} ${ITPP_SRC} ${FFTWF_SRC} ${PWPDF_SRC} ${MIACORE_SRC_PARALLELCXX11})
SET(MIACORE_HEADER ${MIACORE_HEADER_BASE} ${ITPP_HEADER} ${FFTWF_HEADER} ${PWPDF_HEADER})

SET(miacore_deps ${BASELIBS} ${TBB_LIBRARIES} ${FFTWF_LIBRARIES} ${XML_LIBRARIES})
MIA_ADD_LIBRARY(miacore "${MIACORE_SRC}" "${miacore_deps}")

IF(PWPDF_FOUND AND FFTWD_FOUND)
  TARGET_LINK_LIBRARIES(miacore ${PWPDF_LIBRARIES})
ENDIF(PWPDF_FOUND AND FFTWD_FOUND)

IF(ITPP_FOUND)
  TARGET_LINK_LIBRARIES(miacore ${ITPP_LIBRARIES})
ENDIF(ITPP_FOUND)

SET(MIACORE miacore ${BASELIBS})
SET_TARGET_PROPERTIES(miacore PROPERTIES 
  SOVERSION ${LIBRARY_SOVERSION_INFO}
  VERSION ${LIBRARY_VERSION_INFO}
)



#
# the test targets 
#

ADD_EXECUTABLE(test-core ${MIACORETEST_SRC})
ADD_TEST(core test-core)

TARGET_LINK_LIBRARIES(test-core ${MIACORE} ${BOOST_UNITTEST})

IF(WIN32)
  SET_TARGET_PROPERTIES(test-core PROPERTIES LINKER_FLAGS "/NODEFAULTLIB:MSVCRT")
ENDIF(WIN32)

#IF (NOT WIN32)
#  CORE_TEST(history)
#ENDIF (NOT WIN32)
#CORE_TEST(noisegen)

ADD_SUBDIRECTORY(fastica       )
ADD_SUBDIRECTORY(cmeansinit    )
ADD_SUBDIRECTORY(minimizer     )
ADD_SUBDIRECTORY(noise         )
ADD_SUBDIRECTORY(spacialkernel )
ADD_SUBDIRECTORY(splinekernel  ) 
ADD_SUBDIRECTORY(splinebc  ) 
ADD_SUBDIRECTORY(testplug      )

#tests that fork themselfs 
SET(cmdxmlhelp_params  -r 1 --other o)
NEW_TEST_WITH_PARAM(cmdxmlhelp miacore "${cmdxmlhelp_params}")


NEW_TEST(Vector miacore)
NEW_TEST(attributes miacore)
NEW_TEST(boundary_conditions miacore)
NEW_TEST(callback miacore)
NEW_TEST(convergence_measure miacore)
NEW_TEST(cmdoptionflags miacore)
NEW_TEST(cmdparamoption miacore)
NEW_TEST(cmdlineparser miacore)
NEW_TEST(cmdlineparseroutput miacore)
NEW_TEST(cmeans miacore)
NEW_TEST(datapool miacore)
NEW_TEST(delayedparameter miacore)
NEW_TEST(distance miacore)
NEW_TEST(factoryoption miacore)
NEW_TEST(fftslopeclassifier miacore)
NEW_TEST(filetools miacore)
NEW_TEST(fixedwidthoutput miacore)
NEW_TEST(flagstring  miacore)
NEW_TEST(fullstats miacore)
NEW_TEST(handler miacore)
NEW_TEST(histogram miacore)
NEW_TEST(index miacore)
NEW_TEST(interpolator1d miacore)
NEW_TEST(iohandler miacore)
NEW_TEST(kmeans miacore)
NEW_TEST(labelmap miacore)
NEW_TEST(meanvar  miacore)
NEW_TEST(nccsum  miacore)
NEW_TEST(productcache  miacore)
NEW_TEST(property_flags  miacore)
NEW_TEST(scaler1d miacore)
NEW_TEST(seriesstats miacore)
NEW_TEST(singular_refobj miacore)
NEW_TEST(shape miacore)
NEW_TEST(simpson miacore)
NEW_TEST(slopeclassifier miacore)
NEW_TEST(slopestatistics miacore)
NEW_TEST(sparse_solver miacore)
NEW_TEST(sparse_histogram miacore)
NEW_TEST(splinekernel miacore)
NEW_TEST(splineparzenmi miacore)
NEW_TEST(streamvector miacore)
NEW_TEST(statistics miacore)
NEW_TEST(threadedmsg miacore)
NEW_TEST(tools miacore)
NEW_TEST(utils miacore)
#NEW_TEST(watch miacore)
NEW_TEST(waveletslopeclassifier miacore)
NEW_TEST(xmlinterface miacore)

NEW_TEST(gsl_matrix miacore)
NEW_TEST(gsl_matrix_vector_ops miacore)
NEW_TEST(gsl_multimin miacore)
NEW_TEST(gsl_pca miacore)
NEW_TEST(gsl_vector miacore)

IF(FFTWF_FOUND AND WITH_FFTWF)
  NEW_TEST(fft1d miacore)
ENDIF(FFTWF_FOUND AND WITH_FFTWF)

IF(PWPDF_FOUND) 
  NEW_TEST(pwh miacore)
ENDIF(PWPDF_FOUND) 
#
#installation 
#

INSTALL_WITH_EXPORT(miacore)
INSTALL(FILES ${MIACORE_HEADER} DESTINATION ${INCLUDE_INSTALL_PATH}/mia/core)

=== debian/changelog ===
mia (2.4.4-2ubuntu3) artful; urgency=medium

  * Rebuild against new libdcmtk12.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 22 Aug 2017 23:07:25 +0200

mia (2.4.4-2ubuntu2) artful; urgency=medium

  * No-change rebuild for gsl soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 05 Aug 2017 17:58:37 +0000

mia (2.4.4-2ubuntu1) artful; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Reduce parallellism on all 64bit architectures.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 25 Jun 2017 11:20:13 -0700

mia (2.4.4-2) unstable; urgency=medium

  * d/rules: Reduce build-time memory usage on mips/mipsel to fix FTBFS
    Thanks: Adrian Bunk, Closes: #865615
  * d/control: Update standards version to 4.0.0

 -- Gert Wollny <gewo@debian.org>  Fri, 23 Jun 2017 08:07:43 +0000

mia (2.4.4-1) unstable; urgency=medium

  * Re-upload to unstable

 -- Gert Wollny <gewo@debian.org>  Wed, 21 Jun 2017 05:46:59 +0000

mia (2.4.4-1~exp2) experimental; urgency=medium

  * d/control: Add breaks/replaces, closes: #859578

 -- Gert Wollny <gewo@debian.org>  Fri, 07 Apr 2017 06:40:32 +0000

mia (2.4.4-1~exp1) experimental; urgency=medium

  * New upstream version 2.4.4
  * d/p: remove patches applied upstream
  * d/control: 
       - update DD address
       - update package names to new so-version
  * d/: Update install and overrides to new so-version
  * d/control, d/compat: move to new debhelper version

 -- Gert Wollny <gewo@debian.org>  Tue, 21 Mar 2017 22:32:27 +0000

mia (2.4.3-2ubuntu4) zesty; urgency=medium

  * Rebuild against new hdf5

 -- Iain Lane <iain@orangesquash.org.uk>  Tue, 29 Nov 2016 17:35:09 +0000

mia (2.4.3-2ubuntu3) zesty; urgency=high

  * No change rebuild against boost1.62.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 01 Nov 2016 16:29:38 +0000

mia (2.4.3-2ubuntu2) zesty; urgency=medium

  * Reduce parallellism on all 64bit architectures.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 19 Oct 2016 10:12:25 +0200

mia (2.4.3-2ubuntu1) yakkety; urgency=medium

  * Reduce parallellism on amd64

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 11 Sep 2016 18:58:53 +0200

=== debian/control ===
Source: mia
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Gert Wollny <gewo@debian.org>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper (>= 10.0.0),
               libblas-dev,
               libboost-filesystem-dev,
               libboost-serialization-dev,
               libboost-system-dev,
               libboost-test-dev,
               libdcmtk-dev,
               libeigen3-dev,
               libfftw3-dev,
               libgsl-dev,
               libgts-dev,
               libitpp-dev,
               libhdf5-dev,
               libmaxflow-dev,
               libnifti-dev,
               libnlopt-dev,
               libopenexr-dev,
               libpng-dev,
               libtiff-dev,
               libvtk6-dev,
               libvistaio-dev,
               libxml2-dev,
               python-lxml
Build-Depends-Indep: docbook-xsl,
                     doxygen,
                     graphviz,
                     libjs-mathjax,
                     xsltproc
Standards-Version: 4.0.0
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/mia.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/mia.git
Homepage: http://mia.sourceforge.net

Package: libmia-2.4-4
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Breaks: libmia-2.4-0
Replaces: libmia-2.4-0
Description: library for 2D and 3D gray scale image processing
 libmia comprises a set of libraries and plug-ins for general purpose 
 2D and 3D gray scale image processing and basic handling of triangular 
 meshes. The libraries provide a basic infrastructure and  generic 
 algorithms, that can be specialized by specifying the appropriate plug-ins. 

Package: libmia-2.4-dev
Architecture: any
Section: libdevel
Depends: libmia-2.4-4 (= ${binary:Version}),
         mia-doctools (= ${source:Version}),
         libitpp-dev,
         libgsl-dev,
         libboost-test-dev,
         libfftw3-dev,
         libblas-dev,
         ${misc:Depends}
Recommends: libmia-2.4-doc
Conflicts: libmia-2.2-dev
Replaces: libmia-2.2-dev
Description: library for 2D and 3D gray scale image processing, development files
 libmia comprises a set of libraries and plug-ins for general purpose 
 2D and 3D gray scale image processing and basic handling of triangular 
 meshes. The libraries provide a basic infrastructure and  generic 
 algorithms, that can be specialized by specifying the appropriate plug-ins. 
 This package provides the development files for the library.

Package: libmia-2.4-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         libjs-mathjax
Enhances: libmia-2.4-dev
Conflicts: libmia-2.2-doc
Replaces: libmia-2.2-doc
Description: library for 2D and 3D gray scale image processing, documentation
 libmia comprises a set of libraries and plug-ins for general purpose 
 2D and 3D gray scale image processing and basic handling of triangular 
 meshes. The libraries provide a basic infrastructure and  generic 
 algorithms, that can be specialized by specifying the appropriate plug-ins. 
 This package provides the Doxygen generated API reference. 

Package: mia-tools
Architecture: any
Depends: libmia-2.4-4 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Recommends: mia-tools-doc
Suggests: python-nipype
Breaks: python-mia (<= 0.1.6)
Description: Command line tools for gray scale image processing
 Command lines tools to run general purpose image processing tasks on 2D 
 and 3D gray scale images, and basic operations on triangular meshes. 
 Supported image processing algorithms are image filtering, combining, image 
 registration, motion compensation for image series, and the estimation of 
 various statistics over images. 
 This package also contains the nipype interfaces for these command line tools. 

Package: mia-doctools
Architecture: all
Depends: python-lxml,
         python,
         ${misc:Depends}
Conflicts: libmia-2.2-dev
Description: Helper scripts for run-time document creation
 A set of scripts that can be used to create man-pages and on-line
 documentation for programs that make use of the mia command line
 parser and plug-in infrastructure

Package: mia-tools-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Enhances: mia-tools
Description: Cross-referenced documentation of the MIA command line tools
 Cross referenced documentation of the command line tools and plug-ins that 
 are provided by the MIA gray scale image processing tool chain. 
 These lines tools to provide the means to run general purpose image 
 processing tasks on 2D and 3D gray scale images, and basic operations on 
 triangular meshes interactively from the command line. Supported image 
 processing algorithms are image filtering, combining, image registration, 
 motion compensation for image series, and the estimation of various 
 statistics over images.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
 

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed -fvisibility=hidden

# reduce debug info to fix FTBFS on archs with low address space
ifneq (,$(filter $(DEB_HOST_ARCH), mips mipsel))
  export DEB_CFLAGS_MAINT_APPEND = -g1
  export DEB_CXXFLAGS_MAINT_APPEND = -g1
endif

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


# deduce documentation option (build-indep target)
ifeq "" "$(filter %-doc,$(shell dh_listpackages))"
  BUILDDOC = OFF
else
  BUILDDOC = ON
endif

ifeq ($(DEB_HOST_ARCH_BITS),64)
  DEB_BUILD_OPTIONS := $(filter-out parallel=%, $(DEB_BUILD_OPTIONS)) parallel=2
  export DEB_BUILD_OPTIONS
endif

.PHONY: override_dh_strip override_dh_shlibdeps override_dh_auto_test

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
	-DALWAYS_CREATE_DOC=$(BUILDDOC)  \
	-DSTRICT_DEPENDECIES=ON \
	-DMIA_CREATE_MANPAGES=ON \
	-DMIA_CREATE_USERDOC=$(BUILDDOC) \
	-DMIA_CREATE_NIPYPE_INTERFACES=ON

override_dh_builddeb:
	dh_builddeb -- -Z xz

# dh_strip detects executable files, so make *.mia files executable then strip then 
# remove the executable flag 
override_dh_strip:
	`pwd`/debian/run_strip

override_dh_auto_build-indep: 
	dh_auto_build -- doc

override_dh_auto_build-arch: 
	dh_auto_build

override_dh_shlibdeps:
	dh_shlibdeps -- $(shell find  debian/libmia-2.4-4/ -name "*.mia")
